procedure TriangleFLATZ(X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3:single;color:dword;where:gfxImage);
var
      a,b,c,D:single;
      minx,maxx,miny,maxy:word;
      x,y:word;
      z:single;
      f1,f2,f3:single;

begin

        // the plane equation for this triangle: ax + by + cz = d
        a:= (y2 - y1)*(z3 - z1) - (y3 - y1)*(z2 - z1);
        b:= (x2 - x1)*(z3 - z1) - (x3 - x1)*(z2 - z1);
        c:= (x2 - x1)*(y3 - y1) - (x3 - x1)*(y2 - y1);
        D:= -x1*a + y1*b - z1*c;



        minx:= round(min(x1,min(x2, x3)));
        maxx:= round(max(x1,max(x2, x3)));
        miny:= round(min(y1,min(y2, y3)));
        maxy:= round(max(y1,max(y2, y3)));


         for y:=miny to maxy do

           for x:=minx to maxx do begin

                f1:=((x1 - x2) * (y - y1)) - ((y1 - y2) * (x - x1));
                f2:=((x2 - x3) * (y - y2)) - ((y2 - y3) * (x - x2));
                f3:=((x3 - x1) * (y - y3)) - ((y3 - y1) * (x - x3));



                if ( f1 > 0) and ( f2 > 0) and ( f3 > 0) then begin

                            z:= (-D - a*x + b*y)/c;

                         if z > zbuffer[x,y] then begin
                            PutPixel32(x, y, color, where);
                            zbuffer[x,y]:=z;
                        end;
                      

                  
		end;
                
            end;

end;
