procedure TriangleFLATZ(theX1,theY1,theZ1,theX2,theY2,theZ2,theX3,theY3,theZ3:single;color:dword;where:gfxImage);
var v1,v2,v3,Vextra:tV3DVertex;
    s,distance:single;
    deltaY:single;
    stepXright,stepXleft:single;
    Xright,Xleft:single;
    XR,XL:longint;
    cwr:word;
    x,y:longint;
    Ycounter:longint;
    Zright,Zleft:single;
    stepZright,stepZleft:single;
    z,Zadd:single;
    TempS:single;
begin
asm
 push esi
 push edi

// v1.x:=theX1;
// v1.y:=theY1;
mov eax,theX1
mov ebx,theY1

mov v1.x,eax
mov v1.y,ebx


// v1.z:=theZ1;
// v2.x:=theX2;
mov eax,theZ1
mov ebx,theX2

mov v1.z,eax
mov v2.x,ebx

// v2.y:=theY2;
// v2.z:=theZ2;
mov eax,theY2
mov ebx,theZ2

mov v2.y,eax
mov v2.z,ebx

// v3.x:=theX3;
// v3.y:=theY3;
mov eax,theX3
mov ebx,theY3

mov v3.x,eax
mov v3.y,ebx

// v3.z:=theZ3;
mov eax,theZ3
mov v3.z,eax


//  if (v2.y<v1.y) then begin

   fld v2.y
   fld v1.y
  fcom st(1)
  fstsw ax
  sahf
  jc @Below1


//    SWAP v1 with v2

mov eax,v1.x
mov ebx,v2.x
mov v1.x,ebx
mov v2.x,eax

mov eax,v1.y
mov ebx,v2.y
mov v1.y,ebx
mov v2.y,eax

mov eax,v1.z
mov ebx,v2.z
mov v1.z,ebx
mov v2.z,eax

// end;
@Below1:

//  if (v3.y<v1.y) then swapV(v1,v3);

   fld v3.y
   fld v1.y
  fcom st(1)
  fstsw ax
  sahf
  jc @Below2


//    SWAP v1 with v3
mov eax,v1.x
mov ebx,v3.x
mov v1.x,ebx
mov v3.x,eax

mov eax,v1.y
mov ebx,v3.y
mov v1.y,ebx
mov v3.y,eax

mov eax,v1.z
mov ebx,v3.z
mov v1.z,ebx
mov v3.z,eax


// end;
@Below2:
 wait
 finit

//  if (v2.y<v3.y) then swapV(v2,v3);

   fld v2.y
   fld v3.y
  fcom st(1)
  fstsw ax
  sahf
  jc @Below3


//    SWAP v2 with v3

mov eax,v2.x
mov ebx,v3.x
mov v2.x,ebx
mov v3.x,eax

mov eax,v2.y
mov ebx,v3.y
mov v2.y,ebx
mov v3.y,eax

mov eax,v2.z
mov ebx,v3.z
mov v2.z,ebx
mov v3.z,eax



// end;
@Below3:
 wait
 finit

// s:=v2.y-v1.y;
 fld v2.y
 fld v1.y
 fsubp st(1),st
 fst s


//  if s=0 then exit;

   fld s
   fldz
  fcom st(1)
  fstsw ax
  sahf
  jz @MainExit

// Vextra.x:=v1.x+(v2.x-v1.x)*(v3.y-v1.y)/s;
// Vextra.y:=v3.y;
   fld v2.x
   fld v1.x
 fsubp st(1),st
   fld v3.y
   fst Vextra.y
   fld v1.y
 fsubp st(1),st
 fmulp st(1),st
   fld s
   fst st(2)
 fdivp st(1),st
  fadd v1.x
  fst Vextra.x

// distance:=Vextra.x-v3.x;
   fld v3.x
   fsubp st(1),st
   fst distance


// Vextra.z:=v1.z+(v2.z-v1.z)*(v3.y-v1.y)/s;
   fld v2.z
   fld v1.z
 fsubp st(1),st
   fld v3.y
   fld v1.y
 fsubp st(1),st
  fmulp
   fld st(2)
  fdivp st(1),st
   fadd v1.z
   fst Vextra.z


// if (distance>0) then begin
 { * V3 is on the Left-Side of the Triangle * }
 finit
  fldz
   fld distance
  fcom st(1)
 fstsw ax
  sahf
   jbe @distanceJMP

//    stepXright:=(Vextra.x-V1.x)/(Vextra.y-V1.y);
   fld Vextra.x
   fld V1.x
 fsubp st(1),st

   fld Vextra.y
   fld V1.y
 fsubp st(1),st

 fdivp st(1),st
   fst stepXright

   finit

// stepXleft:=(V3.x-V1.x)/(V3.y-V1.y);
   fld V3.x
   fld V1.x
 fsubp st(1),st

   fld V3.y
   fld V1.y
 fsubp st(1),st

 fdivp st(1),st
   fst stepXleft


//    DeltaY:= ceil(v1.y) - v1.y;

   fld v1.y

   mov ax,037Fh
    or ax,0000100000000000b
   mov cwr,ax
 fclex
 fldcw cwr

frndint
    fld v1.y
  fsubp st(1),st
   fst DeltaY
   fst st(2)


//    xLeft:=v1.x+stepXleft*DeltaY;
   fld stepXleft
 fmulp st(1),st
   fld v1.x
 faddp st(1),st
   fst xLeft

//    xRight:=v1.x+stepXright*DeltaY;

   fld stepXright
   fld st(3)
 fmulp st(1),st
   fld v1.x
 faddp st(1),st
   fst xRight

//    stepZright:=(Vextra.z-V1.z)/(Vextra.y-V1.y);

 finit
   fld Vextra.y
   fld V1.y
 fsubp st(1),st
   fst st(2)
   fld Vextra.z
   fld V1.z
 fsubp st(1),st
  fld st(1)
 fdivp st(1),st
   fst stepZright

finit
 //   stepZleft:=(V3.z-V1.z)/(V3.y-V1.y);
   fld v3.y
   fld v1.y
 fsubp st(1),st
   fst st(2)
   fld v3.z
   fld v1.z
 fsubp st(1),st
   fld st(1)
 fdivp st(1),st
   fst stepZleft


//    zLeft:=v1.z+stepZleft*DeltaY;
finit
  fld stepZleft
  fld DeltaY
fmulp st(1),st
  fld v1.z
faddp st(1),st
  fst zLeft

// zRight:=v1.z+stepZright*DeltaY;
finit
  fld stepZright
  fld DeltaY
fmulp st(1),st
  fld v1.z
faddp st(1),st
  fst zRight

//    for y:=ceil(v1.y) to ceil(v3.y)-1 do begin
  finit
    fld v1.y
  fclex
  fldcw cwr
   fist y

    fld v3.y
   fist Ycounter
    dec Ycounter

  mov edx,y
  cmp edx,Ycounter
  ja @Yequ4

@Yloop4:


 // XL:=ceil(Xleft);
 finit
  fld Xleft
 fclex
 fldcw cwr
  fist XL

// XR:=ceil(Xright);

  fld Xright
 fist XR
    wait

//   if (XL>XR) then swapL(XL,XR);
 mov eax,XL
 mov ebx,XR
 cmp eax,ebx
 jle @skipit1

 mov XL,ebx
 mov XR,eax


@skipit1:

 //   zAdd:=(zright-zleft)/(xright-xleft+1);

   fld xright
   fld xleft
 fsubp st(1),st
  fld1
 faddp st(1),st
   fst st(2)
   fld zright
   fld zleft
 fsubp st(1),st
   fld st(1)
 fdivp st(1),st
   fst zAdd

//      z:=zleft;
  mov eax,zleft
  mov z,eax



//  for x:=XL to XR-1 do begin
 mov ebx,XL
 cmp ebx,XR
 je @XLRLequ4
@Xloop4:


//     z:=z+zAdd;
  finit
    fld z
    fld zAdd
  faddp st(1),st
    fst st(1)
   fstp z
   wait

//     if z > getS(zbuffer+(y*xscale+x) shl 2) then begin

  mov eax,y
  mul where.width
  add eax,ebx
  shl eax,2

  mov esi,eax
  mov edi,eax

  add esi,zbuffer


  fld dword ptr [esi]
  fld st(1)
 fcom st(1)

fstsw ax
 sahf
   jc @Ztest4

//                                 PutPixel32(x, y, color, where);
   add edi,where.data
   mov eax,color
   mov [edi],eax
//                                  putS(zbuffer+(y*xscale+x) shl 2,z);
   mov eax, z
   mov [esi],eax
//      end;

@Ztest4:

inc ebx
mov edx,XR
cmp ebx,edx
jb @Xloop4
@XLRLequ4:

finit
//      Xleft:=Xleft+stepXleft;
  fld Xleft
  fld stepXleft
faddp st(1),st
  fst Xleft

//     Xright:=Xright+stepXright;
  fld Xright
  fld stepXright
faddp st(1),st
  fst Xright


//    Zleft:=Zleft+stepZleft;
  fld Zleft
  fld stepZleft
faddp st(1),st
  fst Zleft

//    Zright:=Zright+stepZright;
  fld Zright
  fld stepZright
faddp st(1),st
  fst Zright


inc y
mov eax,y
cmp eax,Ycounter
jbe @Yloop4

@Yequ4:


//   stepXright:=(V2.x-Vextra.x)/(V2.y-Vextra.y);
finit
   fld V2.y
   fld Vextra.y
 fsubp st(1),st
   fst st(1)
   fld V2.x
   fld Vextra.x
 fsubp st(1),st
  fld st(2)
 fdivp st(1),st
   fst stepXright

   finit
//   stepXleft:=(V2.x-V3.x)/(V2.y-Vextra.y);
  fld v2.y
  fld Vextra.y
fsubp st(1),st
  fst st(1)
  fld V2.x
  fld V3.x
fsubp st(1),st
  fld st(2)
fdivp st(1),st
  fst stepXleft

//    DeltaY:= ceil(v3.y) - v3.y;
  finit
    fld v3.y
  fclex
  fldcw cwr
frndint
    fld v3.y
  fsubp st(1),st
    fst DeltaY

//   xLeft:=v3.x+DeltaY*stepXleft;
  fld stepXleft
fmulp st(1),st
  fld v3.x
faddp st(1),st
  fst xLeft

//    xRight:=vextra.x+DeltaY*stepXright;
  fld stepXright
  fld DeltaY
fmulp st(1),st
  fld vextra.x
faddp st(1),st
  fst xRight


//   stepZright:=(V2.z-Vextra.z)/(V2.y-Vextra.y);
  fld V2.y
  fld Vextra.y
fsubp st(1),st
  fst st(1)
  fld V2.z
  fld Vextra.z
fsubp st(1),st
  fld st(1)
fdivp st(1),st
  fst stepZright

// stepZleft:=(V2.z-V3.z)/(V2.y-Vextra.y);
finit
  fld V2.y
  fld Vextra.y
fsubp st(1),st
  fst st(1)
  fld V2.z
  fld v3.z
fsubp st(1),st
  fld st(1)
fdivp st(1),st
  fst stepZleft

//   Zleft:=v3.z+stepZleft*DeltaY;
  fld stepZleft
  fld DeltaY
fmulp st(1),st
  fld v3.z
faddp st(1),st
  fst Zleft

// Zright:=vextra.z+stepZright*DeltaY;
finit
  fld stepZright
  fld DeltaY
fmulp st(1),st
  fld Vextra.z
faddp st(1),st
  fst Zright



// for y:=ceil(v3.y) to ceil(v2.y)-1 do begin
  finit
    fld v3.y
  fclex
  fldcw cwr
   fist y

    fld v2.y
   fist Ycounter
    dec Ycounter

  mov edx,y
  cmp edx,Ycounter
  ja @Yequ3

@Yloop3:


 // XL:=ceil(Xleft);
 finit
  fld Xleft
 fclex
 fldcw cwr
  fist XL

// XR:=ceil(Xright);

  fld Xright
 fist XR
    wait

//   if (XL>XR) then swapL(XL,XR);
 mov eax,XL
 mov ebx,XR
 cmp eax,ebx
 jle @skipit2

 mov XL,ebx
 mov XR,eax


@skipit2:

 //   zAdd:=(zright-zleft)/(xright-xleft+1);

   fld xright
   fld xleft
 fsubp st(1),st
  fld1
 faddp st(1),st
   fst st(2)
   fld zright
   fld zleft
 fsubp st(1),st
   fld st(1)
 fdivp st(1),st
   fst zAdd

//      z:=zleft;
  mov eax,zleft
  mov z,eax

//  for x:=XL to XR-1 do begin
 mov ebx,XL
 cmp ebx,XR
 je @XLRLequ3
@Xloop3:


//     z:=z+zAdd;
  finit
    fld z
    fld zAdd
  faddp st(1),st
    fst st(1)
   fstp z
   wait

//     if z > getS(zbuffer+(y*xscale+x) shl 2) then begin

  mov eax,y
  mul where.width
  add eax,ebx
  shl eax,2

  mov esi,eax
  mov edi,eax

  add esi,zbuffer


  fld dword ptr [esi]
  fld st(1)
 fcom st(1)

fstsw ax
 sahf
   jc @Ztest3

//                                 PutPixel32(x, y, color, where);
   add edi,where.data
   mov eax,color
   mov [edi],eax
//                                  putS(zbuffer+(y*xscale+x) shl 2,z);
   mov eax, z
   mov [esi],eax
//      end;

@Ztest3:

inc ebx
mov edx,XR
cmp ebx,edx
jb @Xloop3
@XLRLequ3:

finit
//      Xleft:=Xleft+stepXleft;
  fld Xleft
  fld stepXleft
faddp st(1),st
  fst Xleft

//     Xright:=Xright+stepXright;
  fld Xright
  fld stepXright
faddp st(1),st
  fst Xright


//    Zleft:=Zleft+stepZleft;
  fld Zleft
  fld stepZleft
faddp st(1),st
  fst Zleft

//    Zright:=Zright+stepZright;
  fld Zright
  fld stepZright
faddp st(1),st
  fst Zright


inc y
mov eax,y
cmp eax,Ycounter
jbe @Yloop3

@Yequ3:


jmp @MainExit

 { * V3 is on the Right-Side of the Triangle * }
@distanceJMP:


 finit
//  if (v2.y<v1.y) then begin

   fld v2.y
   fld v1.y
  fcom st(1)
  fstsw ax
  sahf
  jc @Below4


//    SWAP v1 with v2

mov eax,v1.x
mov ebx,v2.x
mov v1.x,ebx
mov v2.x,eax

mov eax,v1.y
mov ebx,v2.y
mov v1.y,ebx
mov v2.y,eax

mov eax,v1.z
mov ebx,v2.z
mov v1.z,ebx
mov v2.z,eax

// end;
@Below4:

//  if (v3.y<v1.y) then swapV(v1,v3);

   fld v3.y
   fld v1.y
  fcom st(1)
  fstsw ax
  sahf
  jc @Below5


//    SWAP v1 with v3
mov eax,v1.x
mov ebx,v3.x
mov v1.x,ebx
mov v3.x,eax

mov eax,v1.y
mov ebx,v3.y
mov v1.y,ebx
mov v3.y,eax

mov eax,v1.z
mov ebx,v3.z
mov v1.z,ebx
mov v3.z,eax


// end;
@Below5:
 wait
 finit

//  if (v2.y<v3.y) then swapV(v2,v3);

   fld v3.y
   fld v2.y
  fcom st(1)
  fstsw ax
  sahf
  jc @Below6


//    SWAP v2 with v3

mov eax,v2.x
mov ebx,v3.x
mov v2.x,ebx
mov v3.x,eax

mov eax,v2.y
mov ebx,v3.y
mov v2.y,ebx
mov v3.y,eax

mov eax,v2.z
mov ebx,v3.z
mov v2.z,ebx
mov v3.z,eax



// end;
@Below6:


//  Vextra.y:=v2.y;
 mov eax,v2.y
 mov Vextra.y,eax
//    stepXright:=(V2.x-V1.x)/(V2.y-V1.y);
  fld v2.y
  fld v1.y
fsubp st(1),st
  fst st(1)
  fld v2.x
  fld v1.x
fsubp st(1),st
  fld st(1)
fdivp st(1),st
  fst stepXright

//    stepXleft:=(Vextra.x-V1.x)/(Vextra.y-V1.y);
finit
  fld Vextra.y
  fld V1.y
fsubp st(1),st
  fst st(1)
  fld Vextra.x
  fld V1.x
fsubp st(1),st
  fld st(1)
fdivp st(1),st
 fst stepXleft

//    DeltaY:= ceil(v1.y) - v1.y;
    fld v1.y
    fst st(1)
   mov ax,037Fh
    or ax,0000100000000000b
   mov cwr,ax
  fclex
  fldcw cwr
frndint
   fld  st(1)
  fsubp st(1),st
    fst DeltaY

//    xLeft:=v1.x+DeltaY*stepXleft;
    fld stepXleft
  fmulp st(1),st
    fld v1.x
  faddp st(1),st
    fst xLeft


//     xRight:=v1.x+DeltaY*stepXright;
    fld DeltaY
    fld stepXright
  fmulp st(1),st
    fld v1.x
  faddp st(1),st
    fst xRight

//    stepZright:=(V2.z-V1.z)/(V2.y-V1.y);
    fld V2.y
    fld V1.y
  fsubp st(1),st
    fst st(1)
    fld V2.z
    fld v1.z
  fsubp st(1),st
    fld st(1)
  fdivp st(1),st
    fst stepZright

//    stepZleft:=(Vextra.z-V1.z)/(Vextra.y-V1.y);
  finit
    fld Vextra.y
    fld V1.y
  fsubp st(1),st
    fst st(1)
    fld Vextra.z
    fld V1.z
  fsubp st(1),st
    fld st(1)
  fdivp st(1),st
    fst stepZleft

//    zLeft:=v1.z+stepZleft*DeltaY;
   fld DeltaY
   fst st(1)
   fld stepZleft
 fmulp st(1),st
   fld v1.z
 faddp st(1),st
   fst zLeft

//    zRight:=v1.z+stepZright*DeltaY;
 finit
   fld DeltaY
   fld stepZright
 fmulp st(1),st
   fld v1.z
 faddp st(1),st
   fst zRight



// for y:=ceil(v1.y) to ceil(v2.y)-1 do begin
  finit
    fld v1.y
  fclex
  fldcw cwr
   fist y

    fld v2.y
   fist Ycounter
    dec Ycounter

  mov edx,y
  cmp edx,Ycounter
  ja @Yequ2

@Yloop2:


 // XL:=ceil(Xleft);
 finit
  fld Xleft
 fclex
 fldcw cwr
  fist XL

// XR:=ceil(Xright);

  fld Xright
 fist XR
    wait

//   if (XL>XR) then swapL(XL,XR);
 mov eax,XL
 mov ebx,XR
 cmp eax,ebx
 jle @skipit3

 mov XL,ebx
 mov XR,eax


@skipit3:

 //   zAdd:=(zright-zleft)/(xright-xleft+1);

   fld xright
   fld xleft
 fsubp st(1),st
  fld1
 faddp st(1),st
   fst st(2)
   fld zright
   fld zleft
 fsubp st(1),st
   fld st(1)
 fdivp st(1),st
   fst zAdd

//      z:=zleft;
  mov eax,zleft
  mov z,eax


//  for x:=XL to XR-1 do begin
 mov ebx,XL
 cmp ebx,XR
 je @XLRLequ2
@Xloop2:


//     z:=z+zAdd;
  finit
    fld z
    fld zAdd
  faddp st(1),st
    fst st(1)
   fstp z
   wait

//     if z > getS(zbuffer+(y*xscale+x) shl 2) then begin

  mov eax,y
  mul where.width
  add eax,ebx
  shl eax,2

  mov esi,eax
  mov edi,eax

  add esi,zbuffer


  fld dword ptr [esi]
  fld st(1)
 fcom st(1)

fstsw ax
 sahf
   jc @Ztest2

//                                 PutPixel32(x, y, color, where);
   add edi,where.data
   mov eax,color
   mov [edi],eax
//                                  putS(zbuffer+(y*xscale+x) shl 2,z);
   mov eax, z
   mov [esi],eax
//      end;

@Ztest2:

inc ebx
mov edx,XR
cmp ebx,edx
jb @Xloop2
@XLRLequ2:

finit
//      Xleft:=Xleft+stepXleft;
  fld Xleft
  fld stepXleft
faddp st(1),st
  fst Xleft

//     Xright:=Xright+stepXright;
  fld Xright
  fld stepXright
faddp st(1),st
  fst Xright


//    Zleft:=Zleft+stepZleft;
  fld Zleft
  fld stepZleft
faddp st(1),st
  fst Zleft

//    Zright:=Zright+stepZright;
  fld Zright
  fld stepZright
faddp st(1),st
  fst Zright


inc y
mov eax,y
cmp eax,Ycounter
jbe @Yloop2

@Yequ2:


//  if (v3.y-v2.y)=0 then exit;
  fld v3.y
  fld v2.y
fsubp st(1),st

   fldz
  fcom st(1)
  fstsw ax
  sahf
  jz @MainExit

finit
//   stepXright:=(V3.x-V2.x)/(V3.y-V2.y);
   fld v3.y
   fld v2.y
 fsubp st(1),st
   fst st(1)
   fld V3.x
   fld v2.x
 fsubp st(1),st
   fld st(1)
 fdivp st(1),st
   fst stepXright

//   stepXleft:=(V3.x-Vextra.x)/(V3.y-V2.y);
   finit
   fld v3.y
   fld v2.y
 fsubp st(1),st
   fst st(1)
   fld v3.x
   fld Vextra.x
 fsubp st(1),st
   fld st(1)
 fdivp st(1),st
   fst stepXleft



//    DeltaY:= ceil(v2.y) - v2.y;
  finit
    fld v2.y
  fclex
  fldcw cwr
frndint
    fld v2.y
  fsubp st(1),st
    fst DeltaY

//    xLeft:=vextra.x+DeltaY*stepXleft;
    fld stepXleft
  fmulp st(1),st
    fld vextra.x
  faddp st(1),st
    fst xLeft

//    xRight:=v2.x+DeltaY*stepXright;
    fld DeltaY
    fld stepXright
  fmulp st(1),st
    fld v2.x
  faddp st(1),st
    fst xRight


//   stepZright:=(V3.z-V2.z)/(V3.y-V2.y);
    fld V3.y
    fld V2.y
  fsubp st(1),st
    fst st(1)
    fld v3.z
    fld v2.z
  fsubp st(1),st
    fld st(1)
  fdivp st(1),st
    fst stepZright


finit
//   stepZleft:=(V3.z-Vextra.z)/(V3.y-V2.y);
    fld V3.y
    fld V2.y
  fsubp st(1),st
    fst st(1)
    fld v3.z
    fld Vextra.z
  fsubp st(1),st
    fld st(1)
  fdivp st(1),st
    fst stepZleft

//    zLeft:=vextra.z+stepZleft*DeltaY;
    fld DeltaY
  fmulp st(1),st
    fld vextra.z
  faddp st(1),st
    fst zLeft

//    zRight:=v2.z+stepZright*DeltaY;
    fld DeltaY
    fld stepZright
  fmulp st(1),st
    fld v2.z
  faddp st(1),st
    fst zRight

// for y:=ceil(v2.y) to ceil(v3.y)-1 do begin
  finit
    fld v2.y
  fclex
  fldcw cwr
   fist y

    fld v3.y
   fist Ycounter
    dec Ycounter

  mov edx,y
  cmp edx,Ycounter
  ja @Yequ1

@Yloop1:

 // XL:=ceil(Xleft);
 finit
  fld Xleft
 fclex
 fldcw cwr
  fist XL

// XR:=ceil(Xright);

  fld Xright
 fist XR
    wait

//   if (XL>XR) then swapL(XL,XR);
 mov eax,XL
 mov ebx,XR
 cmp eax,ebx
 jle @skipit4

 mov XL,ebx
 mov XR,eax


@skipit4:

 //   zAdd:=(zright-zleft)/(xright-xleft+1);

   fld xright
   fld xleft
 fsubp st(1),st
  fld1
 faddp st(1),st
   fst st(2)
   fld zright
   fld zleft
 fsubp st(1),st
   fld st(1)
 fdivp st(1),st
   fst zAdd

//      z:=zleft;
  mov eax,zleft
  mov z,eax



//  for x:=XL to XR-1 do begin
 mov ebx,XL
 cmp ebx,XR
 je @XLRLequ1
@Xloop1:


//     z:=z+zAdd;
  finit
    fld z
    fld zAdd
  faddp st(1),st
    fst st(1)
   fstp z
   wait

//     if z > getS(zbuffer+(y*xscale+x) shl 2) then begin

  mov eax,y
  mul where.width
  add eax,ebx
  shl eax,2

  mov esi,eax
  mov edi,eax

  add esi,zbuffer


  fld dword ptr [esi]
  fld st(1)
 fcom st(1)

fstsw ax
 sahf
   jc @Ztest1

//                                 PutPixel32(x, y, color, where);
   add edi,where.data
   mov eax,color
   mov [edi],eax
//                                  putS(zbuffer+(y*xscale+x) shl 2,z);
   mov eax, z
   mov [esi],eax
//      end;

@Ztest1:

inc ebx
mov edx,XR
cmp ebx,edx
jb @Xloop1
@XLRLequ1:


finit
//      Xleft:=Xleft+stepXleft;
  fld Xleft
  fld stepXleft
faddp st(1),st
  fst Xleft

//     Xright:=Xright+stepXright;
  fld Xright
  fld stepXright
faddp st(1),st
  fst Xright


//    Zleft:=Zleft+stepZleft;
  fld Zleft
  fld stepZleft
faddp st(1),st
  fst Zleft

//    Zright:=Zright+stepZright;
  fld Zright
  fld stepZright
faddp st(1),st
  fst Zright


inc y
mov eax,y
cmp eax,Ycounter
jbe @Yloop1


@Yequ1:



@MainExit:
pop edi
pop esi

end{$IFDEF PAS_FPC}['EAX','EBX','ECX','EDX','ESI','EDI']{$ENDIF};

end;