procedure TriangleFLATZ(theX1,theY1,theZ1,theX2,theY2,theZ2,theX3,theY3,theZ3:single;color:dword;where:gfxImage);
var v1,v2,v3,Vextra:tV3DVertex;
    s,distance:single;
    deltaY:single;
    stepXright,stepXleft:single;
    Xright,Xleft:single;
    XR,XL:longint;

    x,y:longint;

    Zright,Zleft:single;
    stepZright,stepZleft:single;
    z,Zadd:single;

begin
v1.x:=theX1;
v1.y:=theY1;
v1.z:=theZ1;
v2.x:=theX2;
v2.y:=theY2;
v2.z:=theZ2;
v3.x:=theX3;
v3.y:=theY3;
v3.z:=theZ3;

  if (v2.y<v1.y) then swapV(v1,v2);
  if (v3.y<v1.y) then swapV(v1,v3);
  if (v2.y<v3.y) then swapV(v2,v3);



s:=v2.y-v1.y;
if s=0 then exit;


 Vextra.x:=v1.x+(v2.x-v1.x)*(v3.y-v1.y)/s;
 Vextra.y:=v3.y;
 Vextra.z:=v1.z+(v2.z-v1.z)*(v3.y-v1.y)/s;


 distance:=Vextra.x-v3.x;

 if (distance>0) then begin
 { * V3 is on the Left-Side of the Triangle * }

    stepXright:=(Vextra.x-V1.x)/(Vextra.y-V1.y);
    stepXleft:=(V3.x-V1.x)/(V3.y-V1.y);

    DeltaY:= ceil(v1.y) - v1.y;

    xLeft:=v1.x+stepXleft*DeltaY;
    xRight:=v1.x+stepXright*DeltaY;

    stepZright:=(Vextra.z-V1.z)/(Vextra.y-V1.y);
    stepZleft:=(V3.z-V1.z)/(V3.y-V1.y);

    zLeft:=v1.z+stepZleft*DeltaY;
    zRight:=v1.z+stepZright*DeltaY;

    for y:=ceil(v1.y) to ceil(v3.y)-1 do begin

      XL:=ceil(Xleft);
      XR:=ceil(Xright);

      if (XL>XR) then swapL(XL,XR);

      zAdd:=(zright-zleft)/(xright-xleft+1);
      z:=zleft;

      for x:=XL to XR-1 do begin

                         z:=z+zAdd;

                        if z > getS(zbuffer+(y*xscale+x) shl 2) then begin

                              PutPixel32(x, y, color, where);
                              putS(zbuffer+(y*xscale+x) shl 2,z);
                        end;

      end;

      Xleft:=Xleft+stepXleft;
      Xright:=Xright+stepXright;
      Zleft:=Zleft+stepZleft;
      Zright:=Zright+stepZright;

    end;

   stepXright:=(V2.x-Vextra.x)/(V2.y-Vextra.y);
   stepXleft:=(V2.x-V3.x)/(V2.y-Vextra.y);


    DeltaY:= ceil(v3.y) - v3.y;

    xLeft:=v3.x+DeltaY*stepXleft;
    xRight:=vextra.x+DeltaY*stepXright;


   stepZright:=(V2.z-Vextra.z)/(V2.y-Vextra.y);
   stepZleft:=(V2.z-V3.z)/(V2.y-Vextra.y);

   Zleft:=v3.z+stepZleft*DeltaY;
   Zright:=vextra.z+stepZright*DeltaY;

    for y:=ceil(v3.y) to ceil(v2.y)-1 do begin

      XL:=ceil(Xleft);
      XR:=ceil(Xright);

      if (XL>XR) then swapL(XL,XR);

      zAdd:=(zright-zleft)/(xright-xleft+1);
      z:=zleft;

      for x:=XL to XR-1 do begin

                         z:=z+zAdd;

                        if z > getS(zbuffer+(y*xscale+x) shl 2) then begin

                              PutPixel32(x, y, color, where);
                              putS(zbuffer+(y*xscale+x) shl 2,z);
                        end;

      end;

      Xleft:=Xleft+stepXleft;
      Xright:=Xright+stepXright;
      Zleft:=Zleft+stepZleft;
      Zright:=Zright+stepZright;

    end;


 end else begin
 { * V3 is on the Right-Side of the Triangle * }

    if (v2.y<v1.y) then swapV(v1,v2);
    if (v3.y<v1.y) then swapV(v1,v3);
    if (v3.y<v2.y) then swapV(v2,v3);


    Vextra.y:=v2.y;

    stepXright:=(V2.x-V1.x)/(V2.y-V1.y);
    stepXleft:=(Vextra.x-V1.x)/(Vextra.y-V1.y);

    DeltaY:= ceil(v1.y) - v1.y;

    xLeft:=v1.x+DeltaY*stepXleft;
    xRight:=v1.x+DeltaY*stepXright;

    stepZright:=(V2.z-V1.z)/(V2.y-V1.y);
    stepZleft:=(Vextra.z-V1.z)/(Vextra.y-V1.y);

    zLeft:=v1.z+stepZleft*DeltaY;
    zRight:=v1.z+stepZright*DeltaY;

    for y:=ceil(v1.y) to ceil(v2.y)-1 do begin

      XL:=ceil(Xleft);
      XR:=ceil(Xright);

      if (XL>XR) then swapL(XL,XR);

      zAdd:=(zright-zleft)/(xright-xleft+1);
      z:=zleft;

      for x:=XL to XR-1 do begin

                         z:=z+zAdd;

                        if z > getS(zbuffer+(y*xscale+x) shl 2) then begin

                              PutPixel32(x, y, color, where);
                              putS(zbuffer+(y*xscale+x) shl 2,z);
                        end;

      end;

      Xleft:=Xleft+stepXleft;
      Xright:=Xright+stepXright;
      Zleft:=Zleft+stepZleft;
      Zright:=Zright+stepZright;

    end;


  if (Vextra.y<v1.y) then swapV(v1,Vextra);
  if (V3.y<Vextra.y) then swapV(v3,Vextra);


  if (v3.y-v2.y)=0 then exit;


   stepXright:=(V3.x-V2.x)/(V3.y-V2.y);
   stepXleft:=(V3.x-Vextra.x)/(V3.y-V2.y);

   DeltaY:= ceil(v2.y) - v2.y;

    xLeft:=vextra.x+DeltaY*stepXleft;
    xRight:=v2.x+DeltaY*stepXright;

   stepZright:=(V3.z-V2.z)/(V3.y-V2.y);
   stepZleft:=(V3.z-Vextra.z)/(V3.y-V2.y);

    zLeft:=vextra.z+stepZleft*DeltaY;
    zRight:=v2.z+stepZright*DeltaY;


    for y:=ceil(v2.y) to ceil(v3.y)-1 do begin

      XL:=ceil(Xleft);
      XR:=ceil(Xright);

      if (XL>XR) then swapL(XL,XR);

      zAdd:=(zright-zleft)/(xright-xleft+1);
      z:=zleft;

      for x:=XL to XR-1 do begin

                         z:=z+zAdd;

                        if z > getS(zbuffer+(y*xscale+x) shl 2) then begin

                              PutPixel32(x, y, color, where);
                              putS(zbuffer+(y*xscale+x) shl 2,z);
                        end;

      end;

      Xleft:=Xleft+stepXleft;
      Xright:=Xright+stepXright;
      Zleft:=Zleft+stepZleft;
      Zright:=Zright+stepZright;

    end;


 end;

{
 drawLine32(round(V1.x),round(V1.y),round(V2.x),round(V2.y),RGB32(255,255,255),where);
 drawLine32(round(V1.x),round(V1.y),round(V3.x),round(V3.y),RGB32(255,255,255),where);
 drawLine32(round(V2.x),round(V2.y),round(V3.x),round(V3.y),RGB32(255,255,255),where);

 drawLine32(round(V3.x),round(V3.y),round(Vextra.x),round(Vextra.y),RGB32(255,255,255),where);

 drawTextXY32(round(v1.x),round(v1.y),'1',1,1,rgb32(255,255,255),where);
 drawTextXY32(round(v2.x),round(v2.y),'2',1,1,rgb32(255,255,255),where);
 drawTextXY32(round(v3.x),round(v3.y),'3',1,1,rgb32(255,255,255),where);
 drawTextXY32(round(Vextra.x),round(vextra.y),'e',1,1,rgb32(255,255,255),where);
}
end;